
// MSImula1View.cpp: implementacin de la clase CMSImula1View
//

#include "stdafx.h"
// Se pueden definir SHARED_HANDLERS en un proyecto ATL implementando controladores de vista previa, miniatura
// y filtro de bsqueda, y permiten compartir cdigo de documentos con ese proyecto.
#ifndef SHARED_HANDLERS
#include "MSImula1.h"
#endif

#include "MSImula1Doc.h"
#include "MSImula1View.h"
#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMSImula1View

IMPLEMENT_DYNCREATE(CMSImula1View, CView)

BEGIN_MESSAGE_MAP(CMSImula1View, CView)
	// Comandos de impresin estndar
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CMSImula1View::OnFilePrintPreview)
	ON_WM_CONTEXTMENU()
	ON_WM_RBUTTONUP()
	ON_COMMAND(ID_MYMENU_HOME, &CMSImula1View::OnMymenuHome)
	ON_COMMAND(ID_MYMENU_VISTANORMAL, &CMSImula1View::OnMymenuVistanormal)
	ON_COMMAND(ID_MYMENU_ZOOMUP, &CMSImula1View::OnMymenuZoomup)
	ON_COMMAND(ID_MYMENU_ZOOMDOWN, &CMSImula1View::OnMymenuZoomdown)
	ON_COMMAND(ID_ZOOMDOT, &CMSImula1View::OnZoomdot)
	ON_WM_SETCURSOR()
	ON_WM_LBUTTONDOWN()
END_MESSAGE_MAP()

// Construccin o destruccin de CMSImula1View

CMSImula1View::CMSImula1View()
{
	// TODO: agregar aqu el cdigo de construccin
	m_bHome = TRUE;
	m_rcWin.SetRect(0,1000,1000,0);
	m_bZoombyPoint = FALSE;
}

CMSImula1View::~CMSImula1View()
{
}

BOOL CMSImula1View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: modificar aqu la clase Window o los estilos cambiando
	//  CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// Dibujo de CMSImula1View

void CMSImula1View::OnDraw(CDC* pDC)
{
	CMSImula1Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: agregar aqu el cdigo de dibujo para datos nativos
	CRect rcCli;
	GetClientRect(rcCli);

	CBitmap bmpLandScape;
	bmpLandScape.LoadBitmapA(IDB_BITMAP1);
	CDC DcCompatible;
	DcCompatible.CreateCompatibleDC(pDC);
	DcCompatible.SelectObject(bmpLandScape);

	CRect rcSizeBitmap;
	rcSizeBitmap.SetRectEmpty();
	BITMAP DataBitMap;
	bmpLandScape.GetBitmap(&DataBitMap);
	rcSizeBitmap.right = DataBitMap.bmWidth;
	rcSizeBitmap.bottom = DataBitMap.bmHeight;
	pDC->StretchBlt(0,0,rcCli.Width(),rcCli.Height(),&DcCompatible,0,0,DataBitMap.bmWidth,DataBitMap.bmHeight,SRCCOPY);

	SetMapping(pDC,rcCli,m_rcWin);	

	if ( m_bHome )
	{
	 CBrush BlueBrush(RGB(0,0,255));
	 CObject * pOldObject = pDC->SelectObject(&BlueBrush);
	 pDC->Rectangle(pDoc->m_rcHome);
	 pOldObject = pDC->SelectStockObject(WHITE_BRUSH);
	 pDC->Rectangle(pDoc->m_rcDoor);
	 CBrush RedBrush(RGB(255,0,0));
	 pOldObject = pDC->SelectObject(&RedBrush);
	 pDC->Polygon(pDoc->m_PolyPoints,3);
	}
}
/***********************************************************************************************************************/
void CMSImula1View::SetMapping(CDC * pDC) 
{
	CRect rcCli;
	GetClientRect(rcCli);
	pDC->SetMapMode(MM_ISOTROPIC);
	pDC->SetViewportOrg(0,0);
	pDC->SetViewportExt(rcCli.Width(),rcCli.Height());
	pDC->SetWindowOrg(0,1000);
	pDC->SetWindowExt(1000,-1000);
}

/***********************************************************************************************************************/
void CMSImula1View::SetMapping(CDC * pDC,CRect & rcVP,CRect & rcWin) 
{
	pDC->SetMapMode(MM_ISOTROPIC);
	pDC->SetViewportOrg(rcVP.left,rcVP.top);
	pDC->SetViewportExt(rcVP.Width(),rcVP.Height());
	pDC->SetWindowOrg(rcWin.left,rcWin.top);
	pDC->SetWindowExt(rcWin.Width(),rcWin.Height());
}
// Controladores de mensaje de CMSImula1View


// Impresin de CMSImula1View


void CMSImula1View::OnFilePrintPreview()
{
#ifndef SHARED_HANDLERS
	AFXPrintPreview(this);
#endif
}

BOOL CMSImula1View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Preparacin predeterminada
	return DoPreparePrinting(pInfo);
}

void CMSImula1View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: agregar inicializacin adicional antes de imprimir
}

void CMSImula1View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: agregar limpieza despus de imprimir
}

void CMSImula1View::OnRButtonUp(UINT /* nFlags */, CPoint point)
{
	ClientToScreen(&point);
	OnContextMenu(this, point);
}

void CMSImula1View::OnContextMenu(CWnd* /* pWnd */, CPoint point)
{
#ifndef SHARED_HANDLERS
	theApp.GetContextMenuManager()->ShowPopupMenu(IDR_POPUP_EDIT, point.x, point.y, this, TRUE);
#endif
}


// Diagnsticos de CMSImula1View

#ifdef _DEBUG
void CMSImula1View::AssertValid() const
{
	CView::AssertValid();
}

void CMSImula1View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMSImula1Doc* CMSImula1View::GetDocument() const // La versin de no depuracin es en lnea
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMSImula1Doc)));
	return (CMSImula1Doc*)m_pDocument;
}
#endif //_DEBUG


void CMSImula1View::OnMymenuHome()
{
	m_bHome = !m_bHome;
	InvalidateRect(NULL);
}



void CMSImula1View::OnMymenuVistanormal()
{
	m_rcWin.SetRect(0,1000,1000,0);
	InvalidateRect(NULL);
}


void CMSImula1View::OnMymenuZoomup()
{
	if ( (m_rcWin.Width()>200) && (-m_rcWin.Height()>200) )
	{	 
	 m_rcWin.left += 100;
	 m_rcWin.top -= 100;
	 m_rcWin.right -= 100;
	 m_rcWin.bottom += 100;

	 InvalidateRect(NULL);
	}
}


void CMSImula1View::OnMymenuZoomdown()
{
	 m_rcWin.left -= 100;
	 m_rcWin.top += 100;
	 m_rcWin.right += 100;
	 m_rcWin.bottom -= 100;	    InvalidateRect(NULL);
}


void CMSImula1View::OnZoomdot()
{
	m_bZoombyPoint = TRUE;
}


BOOL CMSImula1View::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	if ( m_bZoombyPoint )
	{
	 HCURSOR hCursor = AfxGetApp()->LoadCursor(MAKEINTRESOURCE(IDC_CURSOR1));
	 SetCursor(hCursor);
	 return TRUE;
	}
	else return CView::OnSetCursor(pWnd, nHitTest, message);
}


void CMSImula1View::OnLButtonDown(UINT nFlags, CPoint PtCursoPos)
{

	if ( (m_rcWin.Width()>100) && (-m_rcWin.Height()>100) )
	{	 
	  CDC * pDC = GetDC();
	  CRect rcCli;
	  GetClientRect(rcCli);
	  SetMapping(pDC,rcCli,m_rcWin);
	  pDC->DPtoLP(&PtCursoPos);
	  int nMiWidth = m_rcWin.Width()/2;
	  int nMiHeight = (m_rcWin.top -  m_rcWin.bottom)/2;
	  m_rcWin.SetRect(PtCursoPos.x - nMiWidth + 50,PtCursoPos.y + nMiHeight - 50,PtCursoPos.x + nMiWidth - 50,PtCursoPos.y - nMiHeight + 50);
	 InvalidateRect(NULL);
	}
	  m_bZoombyPoint = FALSE;
	CView::OnLButtonDown(nFlags, PtCursoPos);
}
